.TH GLEAN 4
.SH NAME
glean \- network reconnaissance
.SH SYNOPSIS
.B ndb/glean
[
.B -p
] [
.B -m mntpt
] [
.B -s srvname
] [
.B -x net
] [
.B -v
]
.SH DESCRIPTION
Glean(4) listens for NetBIOS™, DHCP and BOOTP packets broadcast by other
computers and builds an internal database of any information it discovers.
It provides this information on demand in the form of an ndb(6) file,
usually mounted at
.BR /lib/ndb/gleaned .
.PP
The options are:
.TP
.B -p
Normally glean listens passively, \fB-p\fR enables NetBIOS ``Adapter Status''
probes for hosts it not already known.
.TP
.B -m mntpt
Change the pointpoint of the synthetic filesystem glean provides.
.TP
.B -s srvname
By default glean does not post a p9 endpoint in /srv. If this option is specified
then a mountpoint is posted with the requested name.
.TP
.B -x net
Specifiy an alternate network mountpoint, /net is assumed by default.
.TP
.B -v 
Lookup /lib/oids to get vendor information for any ethernet addresses found,
This can help identify particular equipment and virtual machines.
.SH REPORT
The ndb(6) report file contains entries for hosts and domains. Entries
may also contain some additional records giving OS specific info:
.PP
.TP
.I nb-role
This identifies hosts which have specific roles in the NetBIOS network:
.br
	LMB	Local Master Broswers
.br
	PBM	Potential Master Broswers
.br
	DBM	Domain Master Broswers
.br
	BMB	Backup Master Broswers
.br
	DC	Domain Controller
.br
.TP
.I hinfo
If the host's Operating system can be identified it is an hinfo record
containing this information.
.TP
.I vendor
When the Ethernet MAC address is known, a vendor 
record is added.
.TP
.I srv
Hosts offering services to other machines gain srv
records.
.TP
.I txt
If a descriptive name is available for a machine it is put in a 
txt record.
.TP
.I failed
If a host broadcasts a request for a NetBIOS name and receives no reply that host
is given a failed record with the requested name.
This information can be useful in diagnosing slow or unresponsive Windows networks.
.SH FILES
/lib/ndb/gleaned
.br
/sys/src/cmd/ndb/glean/*
.br
/lib/oui
.SH BUGS
There is no support for zeroconf as used by Apple computers.
.PP
Running glean(4) prevents the host from advertising itself on
NetBIOS due to buggy NetBIOS implementations from Microsoft which
always reply to port 137 rather than the source port of the request.
