#include <u.h>
#include <libc.h>
#include <ip.h>
#include <bio.h>
#include <ndb.h>
#include "nbcache.h"

static struct {
	int port;
	Disect *func;
	char *name;
} Known[] = {
	{ 137,	nbns,	"nbns" },
	{ 67,	dhcp,	"dhcp" },
	{ 138,	browse,	"browse" },
	{ 9823,	iap,	"iap" },
	{ 4242,	iap,	"iap" },		/* depricated port number - is also used by a virus. */
};


void
listener(void)
{
	Pkt *p;
	int fd, cfd, port, i;
	char addr[32], dir[40], tmp[40];

	p = allocpkt(1024);

	snprint(addr, sizeof(addr), "%s/udp!*!*", Netdir);
	if((cfd = announce(addr, dir)) < 0)
		sysfatal("%s - %r\n", addr);
	if(fprint(cfd, "headers") < 0)
		sysfatal("can't set header mode: %r");
	sprint(tmp, "%s/data", dir);
	if((fd = open(tmp, ORDWR)) < 0)
		sysfatal("%s - %r\n", tmp);
	close(cfd);

	while(1){
		readpkt(fd, p);

		port = nhgets(p->up->lport);
		for(i = 0; i < nelem(Known); i++)
			if(port == Known[i].port)
				break;
		if(i < nelem(Known)){
			if(setjmp(p->err) == 0)
				(*Known[i].func)(p);
			else
				fprint(2, "%s: %s decode failed, %r\n", argv0, Known[i].name);
		}

	}
}

